#include "Arduino.h"
#include "dust.h"

DustSensor::DustSensor(int pin)
{
  _pin = pin;
}

void DustSensor::begin()
{
  pinMode(_pin, INPUT);
  lowpulseoccupancy = 0;
  _starttime = millis();//get the current time;
}

void DustSensor::heartbeat()
{
  _duration = pulseIn(_pin, LOW);
  lowpulseoccupancy = lowpulseoccupancy+_duration;
}

boolean DustSensor::isReady()
{
  unsigned long currentMillis = millis();
 
  if ((millis()-_starttime) > _sampletime_ms)
    return true;
  else
    return false;
}

void DustSensor::computeValues()
{
    ratio = lowpulseoccupancy/(_sampletime_ms*10.0);  // Integer percentage 0=>100
    concentration = 1.1*pow(ratio,3)-3.8*pow(ratio,2)+520*ratio+0.62; // using spec sheet curve
}
